Subject: RE: [AVT] RTP/RTCP Timestamp and transmission time

From: "Allison, Art" <[email-masked]>
Date: Thu, 18 Sep 2003 08:53:10 -0400

Be aware that real MPEG-2 streams often contain time line discontinuities,
which are signaled via the discontinuity_indicator in the MPEG transport
packets' adaptation field.

Art
::{)
Art Allison
Director Advanced Engineering
NAB
1771 N St NW
Washington DC 20036
202 429 5418

-----Original Message-----
From: Colin Perkins [mailto:[email-masked]]
Sent: Thursday, September 18, 2003 7:57 AM
To: Lorenzo Polidori
Cc: [email-masked]
Subject: Re: [AVT] RTP/RTCP Timestamp and transmission time

On Thursday, Sep 18, 2003, at 11:31 Europe/London, Lorenzo Polidori 
wrote:
> Colin Perkins wrote:
>
>> The RTP timestamp is NOT calculated from the NTP timestamp, but
>> represents a sampling of the media clock.
>
> Ok, thank you. But can you explain the exact meaning of the following
> fragment of RFC 3550, section 6.4.1:
> "Note that in most cases this timestamp [RTP timestamp of an SR-RTCP 
> packet]
> will not be equal to the RTP timestamp in any adjacent data packet. 
> Rather,
> it MUST be calculated from the corresponding NTP timestamp using the
> relationship between the RTP timestamp counter and real time as 
> maintained
> by periodically checking the wallclock time at a sampling instant".

This is for the particular case of estimating the RTP timestamp value 
to include in an RTCP SR packet, if it is not possible to sample the 
RTP clock at arbitrary instants.

A system that cannot sample the RTP clock at arbitrary times, and which 
has no NTP-format clock, will have to set the RTP timestamp in an RTCP 
SR to zero. Systems that have no local clock are very rare though, so 
this should almost never be a concern.

> Now, I have an MPEG2 Elementary Stream (ES), stored on disk, to be
> transmitted over RTP. From Elementary Stream I can get and convert 
> MPEG time
> code & temporal reference to a 90 kHz RTP timestamp, as in RFC 2250. 
> So, I
> put this RTP timestamp in RTP data packet header: this timestamp is 
> computed
> from the MPEG2 time code stored on disk, so it isn't correlated to the
> system wallclock current time.

You need to schedule the transmission time of the RTP packets according 
to their RTP timestamp. Since the packets are timed, there is a 
correlation with the wall-clock.

> If I get RTP timestamp of SR-RTCP packet
> sampling the wallclock current time, what's the correlation between RTP
> timestamp on RTP data packet and RTP timestamp on RTCP packet?

The RTP timestamps in data packets and in RTCP SR packets are samples of
the same conceptual clock, at the instant that packet is generated. The
wall-clock time is always correlated with the RTP timestamp, although it
is a separate clock (since the RTP timestamps are derived from the media
timing).

-- 
Colin Perkins
http://csperkins.org/

_______________________________________________
Audio/Video Transport Working Group
[email-masked]
https://www1.ietf.org/mailman/listinfo/avt

_______________________________________________
Audio/Video Transport Working Group
[email-masked]
https://www1.ietf.org/mailman/listinfo/avt

---

From: Lorenzo Polidori <[email-masked]>
Date: Fri, 19 Sep 2003 09:53:50 +0200 (added by [email-masked])

>correlation with the wall-clock.

Ok, now it's clear, thanks all. But I have an other question. I must
schedule  the transmission time of the RTP packets and the packets
containing the same MPEG2 picture have the same RTP TS, since the time
reference of the slides belonging to the same picture does not change. Am I
obliged to send a burst of RTP data packets every MPEG2 scheduled picture,
containing all the relative slides?

Wall clock:       0------------10----------20-----------30
Send time:       |           |        |            |        |
                        PB       PB    PB       PB    PB  .......

PB=Burst of RTP Packets containing all the slides of an MPEG picture, with
the same RTP packets, according to RFC 2250, section 3.3.

Best Regards
Lorenzo

/*******************************************************************\
*    Lorenzo POLIDORI
*    company:    BLT Italia srl        web:  http://www.blt.it
*    address:    via Rosselli, 91     city:  Lido di CAMAIORE
*    country:    ITALY                 zip:  55043-i
*    Tel. +39 0584 904788  Fax +39 0584 904789  e-mail: [email-masked]
\*******************************************************************/